<!-- eslint-disable vue/valid-v-for -->
<template>
  <q-select
    v-model="internalValue"
    style="min-width: 150px"
    :dense="dense"
    :filled="filled"
    :multiple="multiple"
    :label="label"
    :use-chips="multiple"
    emit-value
    stack-label
    map-options
    option-value="id"
    option-label="codigo_full"
    @update:model-value="updateValue"
    :options="options"
    :hide-bottom-space="hideBottomSpace"
    :error-message="errorMessage"
    :error="error"
    :disable="loading"
    use-input
    input-debounce="0"
    @filter="filterFn"
  >
    <template v-slot:prepend>
      <q-icon name="account_tree" v-if="!loading" />
      <q-spinner v-if="loading" />
    </template>
    <template v-slot:no-option>
      <q-item>
        <q-item-section class="text-grey"> Sin Resultados </q-item-section>
      </q-item>
    </template>
    <template v-slot:after>
      <q-btn square color="primary" icon="person_search">
        <q-menu>
          <q-list style="min-width: 100px">
            <q-item
              v-if="store.details.is.distrito"
              clickable
              v-close-popup
              @click="getOrganismos('distrito')"
            >
              <q-item-section>Mi Distrito</q-item-section>
            </q-item>
            <q-item
              v-if="store.details.is.zona"
              clickable
              v-close-popup
              @click="getOrganismos('zona')"
            >
              <q-item-section>Mi Zona</q-item-section>
            </q-item>
            <q-item
              v-if="store.details.is.nacion || store.details.is.zona"
              clickable
              v-close-popup
              @click="getOrganismos('todos')"
            >
              <q-item-section>Todo</q-item-section>
            </q-item>
          </q-list>
        </q-menu>
      </q-btn>
    </template>
  </q-select>
</template>

<script lang="ts">
import {
  defineComponent,
  PropType,
  ref,
  watch,
  reactive,
  onMounted,
  toRefs,
} from 'vue';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { useUserStore } from 'src/stores/user';

interface Form {
  query: string;
  distrito: number | null | undefined;
  zona: number | null | undefined;
}

export default defineComponent({
  name: 'MyInput',
  props: {
    modelValue: {
      type: Number as PropType<number | null | undefined>,
      required: true,
    },
    label: {
      type: String as PropType<string>,
      required: false,
      default: 'Listado Organismos',
    },

    dense: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    filled: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    multiple: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    distrito: {
      type: Number as PropType<number | null | undefined>,
      required: false,
    },

    zona: {
      type: Number as PropType<number | null | undefined>,
      required: false,
    },

    error: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: false,
    },
    errorMessage: {
      type: String as PropType<string>,
      required: false,
    },

    hideBottomSpace: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: false,
    },
  },

  emits: ['update:modelValue', 'change'],
  setup(props, { emit }) {
    const store = useUserStore();
    const loading = ref(true);
    const { modelValue } = toRefs(props);
    const internalValue = ref(modelValue);
    watch(
      () => props.modelValue,
      (newValue: number | null | undefined) => {
        internalValue.value = newValue;
      }
    );

    function updateValue(value: number) {
      internalValue.value = value;
      emit('update:modelValue', value);
      emit('change', value);
    }
    /******************************************************************** */

    onMounted(() => {
      // el componente recive como parametro el UUID de una persona, pero debe mostrar el nombre.
      getOrganismos('zona');
    });

    const form = reactive<Form>({
      query: '',
      distrito: props.distrito,
      zona: props.zona,
    });

    const stringOptions = ref([]);
    const options = ref(stringOptions);

    function getOrganismos(tipo: string) {
      loading.value = true;
      stringOptions.value = [];

      switch (tipo) {
        case 'distrito':
          form.distrito = store.details.organismos.distrito;
          form.zona = store.details.organismos.zona;
          break;
        case 'zona':
          form.distrito = null;
          form.zona = store.details.organismos.zona;
          break;
        case 'todos':
          form.distrito = null;
          form.zona = null;
          break;
        default:
          form.distrito = null;
          form.zona = store.details.organismos.zona;
          break;
      }

      console.log(form.distrito);
      console.log(form.zona);

      api
        .get('/api/organismos', {
          params: form,
        })
        .then((response: AxiosResponse) => {
          stringOptions.value = response.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function filterFn(val: string, update) {
      if (val === '') {
        update(() => {
          options.value = stringOptions.value;
        });
        return;
      }

      update(() => {
        const needle = val.toLowerCase();
        options.value = stringOptions.value.filter((v) => {
          return v.codigo_full.toLowerCase().indexOf(needle) > -1;
        });
      });
    }

    return {
      loading,
      internalValue,
      updateValue,
      options,
      getOrganismos,
      store,
      filterFn,
    };
  },
});
</script>
